/*****************************************************
Chip type               : mega8
AVR Core Clock frequency: 16,000000 MHz
*****************************************************/
#include <mega8.h>
#include <ini.h>
#include <stdlib.h>
#include <delay.h> 
#include <bcd.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=5
   .equ __scl_bit=4
#endasm
#include <i2c.h>

// DS1307 Real Time Clock functions
#include <ds1307.h>

#define MEGA8_SMD 1

#define   IN_595    PORTB.5
#define   SH_595    PORTD.4
#define   ST_595    PORTD.3
 
#define   key_plus  PORTD.1 == 0
#define   key_minus PORTD.0 == 0


               //{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char led_r[64];//{200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char led_g[64];//{0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char led_b[64];//{0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char led=0;
unsigned char _hour24, _hour, _min60, _min, _sec;
unsigned char  s_hour=24, s_min=60, s_sec=60; 
char i=0,mode=0;
char r_l=0,r_m=50,r_h=255;
char g_l=0,g_m=50,g_h=255;
char b_l=0,b_m=50,b_h=255;
char b_w=50,g_w=50,r_w=50;
unsigned char foto_h, foto_m;

//==============================================================================
// Timer 0 overflow interrupt service routine
// Clock value: 16000 kHz TCCR0=0x02;
//==============================================================================
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// OFF  
OCR1AL=0; //R
OCR1BL=0; //G
OCR2=  0; //B
delay_us(15); 

SH_595 = 0; //   595
if (led==0) IN_595 = 0; else IN_595 = 1;
ST_595 = 0; //   595

SH_595 = 1; //  
ST_595 = 1; //  
OCR2=  led_b[led]; //B
OCR1AL=led_r[led]; //R
OCR1BL=led_g[led]; //G
//------------------------------------------
led++;    
if (led==60) led = 0;

}    

//==============================================================================
//    1 2 3 - 10 11 12 
//================================================================================                                        
void hour_white(void)
{

led_r[4]=r_w;led_g[4]=g_w;led_b[4]=b_w;
led_r[9]=r_w;led_g[9]=g_w;led_b[9]=b_w;
led_r[14]=r_w;led_g[14]=g_w;led_b[14]=b_w;
led_r[19]=r_w;led_g[19]=g_w;led_b[19]=b_w;
led_r[24]=r_w;led_g[24]=g_w;led_b[24]=b_w;
led_r[29]=r_w;led_g[29]=g_w;led_b[29]=b_w;
led_r[34]=r_w;led_g[34]=g_w;led_b[34]=b_w;
led_r[39]=r_w;led_g[39]=g_w;led_b[39]=b_w;
led_r[44]=r_w;led_g[44]=g_w;led_b[44]=b_w;
led_r[49]=r_w;led_g[49]=g_w;led_b[49]=b_w;
led_r[54]=r_w;led_g[54]=g_w;led_b[54]=b_w;
led_r[59]=r_w;led_g[59]=g_w;led_b[59]=b_w;

}

//==============================================================================
//  
//================================================================================                                        
/*
void clear_red(void) 
{
i=0;
while(i<60)
    {
        led_r[i]=r_l;
        i++;
    };                 
}
*/

//==============================================================================
//  
//================================================================================    
void clock()
{
i=0;


//    b_w=foto;
//    g_w=foto;
//    r_w=foto;
             
    
while(i<60)
    {
        led_g[i]=g_l;
        led_r[i]=r_l;
        i++;
    };
    
hour_white();

led_g[_min+1]= g_m;
led_g[_min-1]= g_m;
if(_min==0)led_g[0]= g_m;
if(_min==59)led_g[59]= g_m;
led_g[_min]=g_h;
led_r[_min]=r_l;
led_b[_min]=b_l;

led_r[_hour]= r_h; 
led_b[_hour]= b_l;
led_g[_hour]= g_l;
led_r[_hour+1]= r_m;
led_r[_hour-1]= r_m;
if(_hour==59)led_r[0]= r_m;

}

//==============================================================================
//   
//================================================================================    
void sec_blue()
{
char s=0; 
//static char m=0;//abs(_min)%3;
i=0;
led_b[0]=b_h;
if(mode==0)
{
 while(i<10)
    {
        led_b[i]=b_l;
        //led_b[i+4]=b_l;
        led_b[i+9]=b_l;
        //led_b[i+14]=b_l;
        led_b[i+19]=b_l;
        //led_b[i+24]=b_l; 
        led_b[i+29]=b_l;
        //led_b[i+34]=b_l; 
        led_b[i+39]=b_l;
       // led_b[i+44]=b_l; 
        led_b[i+49]=b_l;
        //led_b[i+54]=b_l; 
        i++;
        delay_ms(60);
    };
}
else if(mode==1)
{
  i=60;
  while(i>0)
    {
        led_b[i-1]=b_l;
        i--;
        delay_ms(10);
    };
}
else if(mode==2)
{
 i=30;
 s=29;
 while(i<60)
    {
        led_b[s]=b_l;
        led_b[i]=b_l;
        i++;
        s--;
        delay_ms(20);
    };
};
mode++;
if(mode==3) mode=0;    
}    

//==============================================================================
//      
//================================================================================    
void clear_rgb()
{
 i=0;
 while(i<60)
    {
        led_r[i]=r_l;
        led_b[i]=g_l;
        led_g[i]=b_l;
        i++;
    };
}

//==============================================================================
//  
//================================================================================        
void demo_rgb(char r, char g, char b)
{
i=0;
while(i<60)
    {
        led_r[i]=r;//i*r+10;
        led_g[i]=g;//i*g+10;
        led_b[i]=b;//i*b+10;
        i++;
        delay_ms(5);
    };

tone(200); 
delay_ms(3000);
}
 
//==============================================================================
//  
//================================================================================                                        
void  scan_key(void) 
{ 
if(PIND.0 == 0 || PIND.1 == 0) 
    {
    delay_ms(10); 
      if(PIND.0 == 0)
        {
         tone(100);
         if(_hour24<12)  
            {
                _hour24++;
            }
         else
            {
                _hour24=0;
            };   
          rtc_set_time(_hour24, _min60, 0);
          delay_ms(100);  
        } 
        
      else if(PIND.1 == 0)
        {
         tone(50);             
         if(_min60<59)  
            {
                _min60++;
            }
         else
            {
                _min60=0;
            };   
          rtc_set_time(_hour24, _min60, 0);
          delay_ms(100);
        };
    }; 
}



//==============================================================================
//================================== main =====================================
//==============================================================================
void main(void) 
{
// Init mega_8
ini_m8();
#asm("sei")


//    
//demo_rgb(4,0,0); //  
//demo_rgb(0,4,0); // 
//demo_rgb(0,0,4); // 
demo_rgb(255,255,255);   //      .

clear_rgb();
hour_white();

// I2C Bus initialization
i2c_init();
// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 0
rtc_init(0, 1, 0); 
//    
_sec = rtc_read(0x00);   //  
delay_ms(1100);         //  1.1 
//    
if (_sec == rtc_read(0x00)) // Start clock  00:00:00
        {
           rtc_set_time(0x00, 0x00, 0x00);
           rtc_set_date(0x01, 0x01, 0x21);
           tone(250);
        };

// --------------------------------   -----------------------------
 while (1) 
 {
    #asm ("wdr") 
    
    foto_h=read_adc(1);     //  
    
    if(foto_h<50)foto_h=50; //  ,  

    foto_m= foto_h/5;       //  
    if(foto_m<10)foto_m=10;
    
    //r_l=0,
    r_m=foto_m;
    r_h=foto_h;
    //g_l=0,
    g_m=foto_m;
    g_h=foto_h;
    //b_l=0,
    b_m=foto_m;
    b_h=foto_h;
    
    foto_m=foto_m*2;
    b_w=foto_m;
    g_w=foto_m;
    r_w=foto_m;
    
    
    scan_key();
    delay_ms(100);
    rtc_get_time(&_hour24, &_min60, &_sec);
    _hour = _hour24;
    if(_hour >= 12) _hour = (_hour-12); // 12     24
    _hour = _hour*5;                    //      : 4  = 20 
    
    //   ,    ,    120  .
    //    HC595       1 ->59  2->58  60->0 
    _hour = 59 -_hour;                  //    
    _min = 59 -_min60;                  // 
    _sec = 59 -_sec;                    //  
    
    if(s_hour != _hour)
      {  
        clock();
        s_hour = _hour;
        s_min=_min; 
      }
    else
    {    
      if(s_min != _min)
      {
          clock();
          s_min=_min;
      };  
    };
    
    if(s_sec != _sec)
      {   
        beep_on;       // 
        delay_ms(1);   // 1-10 
        beep_off;
                     
          if(_sec==59)  //   0 
            { 
                //led_b[0]=b_h;
                sec_blue();
                //clock();
               
            }
          else 
            {   if(led_g[s_sec]==g_h || led_r[s_sec]==g_h) //    
                    {
                        led_b[s_sec]=b_l;
                    }
                else
                    {
                         led_b[s_sec]=b_m;
                    };
               //clock();
            }; 
          clock();
          if(mode == 0)led_b[s_sec]=b_l; //   
          led_b[_sec]=b_h;
          s_sec=_sec;  
            
      };
      
     if(_min == _hour) //        :  3:15    
      {
          led_g[_min+1]=g_l;
          led_g[_min-1]=g_l;
          led_r[_min+1]=r_h;
          led_r[_min-1]=r_h;
          if(_hour==0)led_r[0]= r_h; 
          if(_hour==0)led_g[0]= r_l;
          led_r[_min]=r_l;
          led_g[_min]=g_h;
      }; 
       
    
    
 };                                    
 
} // EOF
