#include <mega8.h>
#include <delay.h>
#include "ini.h"

// 8 ,   = AVCC
//#define ADC_VREF_TYPE 0x40//10bit // 60-8bit

//  2,56V
#define ADC_VREF_TYPE 0xE0


//=============================================================
void ini_m8(void)
{
// Input/Output Ports initialization

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T  
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
PORTD=0x03; //3
DDRD=0xFC;  //C


// Timer/Counter 0 initialization
//  0 250,000 kHz   (16000000/64)
TCCR0=0x02;          
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 16000,000 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xA1;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 16000,000 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x69;
TCNT2=0x00;
OCR2=0x00;


// External Interrupt(s) initialization
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01; 
//TIMSK=0x05; //x05-timer0 i timer1    x01-timer0

// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
SFIOR=0x00;

// ADC disabled
//ADCSRA=0x00;


// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AVCC pin
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
//ADCSRA=0x86;  // 80   83-1000Khz  85-250Khz   86-125k
ADCSRA=0x83;

// SPI disabled
SPCR=0x00;
// TWI disabled
TWCR=0x00;

WDTCR=0x1F;
WDTCR=0x0F;
#asm ("wdr")
}


//==============================================================
// ( 100~1
//==============================================================
void tone(char b)
{
  while (--b>0)
  {
        beep_on;
        delay_us(200);
        beep_off;  
        delay_us(200);
    };
}


// 8 ,   = AVCC
//==============================================================
// Read the 8 most significant bits of the AD conversion result
//==============================================================
unsigned char read_adc(unsigned char adc_input)
{
    ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
    //    
    delay_us(10);
    ADCSRA|=0x40;
    //   
    while ((ADCSRA & 0x10)==0);
    ADCSRA|=0x10;
return ADCH;
}


/*
//==============================================================
// Read the 8 most significant bits of the AD conversion result
//==============================================================
unsigned char read_adc(unsigned char adc_input)
{
    ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
    //    
    delay_us(10);
    ADCSRA|=0x40;
    //   
    while ((ADCSRA & 0x10)==0);
    ADCSRA|=0x10;
return ADCH;
}

*/